Unit DE92RS_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AIG2R_p, DE92RK_p;

procedure DE92RS(F :Proc_F_DE; M :Integer; var Y :Array of Real;
                X :Real; var A :Array of Real; H :Real;
                var R :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var R4 :Array of Real; var B :Array of Real);

implementation

procedure DE92RS(F :Proc_F_DE; M :Integer; var Y :Array of Real;
                X :Real; var A :Array of Real; H :Real;
                var R :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var R4 :Array of Real; var B :Array of Real);
var
I,J :Integer;
IR1 :Array of Integer;
C :Array [0..7] of Real;
label
_20,_10,_50,_60,_70,_80;
begin
{   DATA  FORTRAN  }
C[0] := 0.125;
C[1] := 0.375;
C[2] := 0.7916666666666667;
C[3] := -0.1666666666666667;
C[4] := 2.1666666666666667;
C[5] := 0.1666666666666667;
C[6] := -2.0;
C[7] := 0.6666666666666667;
{    BOHEHE OHOO AA   A B T O H O M H O   CCTEM }
{    E KOHTPO TOHOCT (C AAHHO MATPE KO). }
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    B[(I-1)+(J-1)*M] := -H*A[(I-1)+(J-1)*M];
_20:
   end;
  B[(J-1)+(J-1)*M] := B[(J-1)+(J-1)*M] + 1.0;
_10:
 end;
{ AIG2R (B,R1,M); }
{  18.02.2009   . }
{      IR1   R1  / AIG2R }
SetLength(IR1,2*M);
AIG2R (B,IR1,M);
F (X,Y,R1,M);
DE92RK (M,B,R1,H,R2);
for I:=1 to M do
 begin
_50:
  R1[I-1] := Y[I-1] - R2[I-1];
 end;
F (X,R1,R3,M);
DE92RK (M,B,R3,H,R1);
for I:=1 to M do
 begin
_60:
  R3[I-1] := Y[I-1] + C[0]*R2[I-1] + C[1]*R1[I-1];
 end;
F (X,R3,R4,M);
DE92RK (M,B,R4,H,R3);
for I:=1 to M do
 begin
_70:
  R4[I-1] := Y[I-1] + C[1]*R2[I-1] + C[2]*R1[I-1] + C[3]*R3[I-1];
 end;
F (X,R4,R,M);
DE92RK (M,B,R,H,R4);
for I:=1 to M do
 begin
_80:
  R[I-1] := Y[I-1] + C[4]*R2[I-1] + C[5]*R1[I-1] + C[6]*R3[I-1] +
    C[7]*R4[I-1];
 end;
end;

end.
